<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LearnerHandler.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">LearnerHandler.java</span></div><h1>LearnerHandler.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.util.LinkedList;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.locks.ReentrantReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock.ReadLock;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.KeeperException.SessionExpiredException;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.server.ByteBufferInputStream;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.ZooKeeperThread;
import org.apache.zookeeper.server.ZooTrace;
import org.apache.zookeeper.server.quorum.Leader.Proposal;
import org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType;
import org.apache.zookeeper.server.util.SerializeUtils;
import org.apache.zookeeper.server.util.ZxidUtils;
import org.apache.zookeeper.txn.TxnHeader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * There will be an instance of this class created by the Leader for each
 * learner. All communication with a learner is handled by this
 * class.
 */
public class LearnerHandler extends ZooKeeperThread {
<span class="fc" id="L58">    private static final Logger LOG = LoggerFactory.getLogger(LearnerHandler.class);</span>

    protected final Socket sock;    

    public Socket getSocket() {
<span class="fc" id="L63">        return sock;</span>
    }

    final Leader leader;

    /** Deadline for receiving the next ack. If we are bootstrapping then
     * it's based on the initLimit, if we are done bootstrapping it's based
     * on the syncLimit. Once the deadline is past this learner should
     * be considered no longer &quot;sync'd&quot; with the leader. */
    volatile long tickOfNextAckDeadline;
    
    /**
     * ZooKeeper server identifier of this learner
     */
<span class="fc" id="L77">    protected long sid = 0;</span>
    
    long getSid(){
<span class="fc" id="L80">        return sid;</span>
    }                    

<span class="fc" id="L83">    protected int version = 0x1;</span>
    
    int getVersion() {
<span class="fc" id="L86">    	return version;</span>
    }
    
    /**
     * The packets to be sent to the learner
     */
<span class="fc" id="L92">    final LinkedBlockingQueue&lt;QuorumPacket&gt; queuedPackets =</span>
        new LinkedBlockingQueue&lt;QuorumPacket&gt;();

    /**
     * This class controls the time that the Leader has been
     * waiting for acknowledgement of a proposal from this Learner.
     * If the time is above syncLimit, the connection will be closed.
     * It keeps track of only one proposal at a time, when the ACK for
     * that proposal arrives, it switches to the last proposal received
     * or clears the value if there is no pending proposal.
     */
<span class="fc" id="L103">    private class SyncLimitCheck {</span>
<span class="fc" id="L104">        private boolean started = false;</span>
<span class="fc" id="L105">        private long currentZxid = 0;</span>
<span class="fc" id="L106">        private long currentTime = 0;</span>
<span class="fc" id="L107">        private long nextZxid = 0;</span>
<span class="fc" id="L108">        private long nextTime = 0;</span>

        public synchronized void start() {
<span class="fc" id="L111">            started = true;</span>
<span class="fc" id="L112">        }</span>

        public synchronized void updateProposal(long zxid, long time) {
<span class="fc bfc" id="L115" title="All 2 branches covered.">            if (!started) {</span>
<span class="fc" id="L116">                return;</span>
            }
<span class="fc bfc" id="L118" title="All 2 branches covered.">            if (currentTime == 0) {</span>
<span class="fc" id="L119">                currentTime = time;</span>
<span class="fc" id="L120">                currentZxid = zxid;</span>
            } else {
<span class="fc" id="L122">                nextTime = time;</span>
<span class="fc" id="L123">                nextZxid = zxid;</span>
            }
<span class="fc" id="L125">        }</span>

        public synchronized void updateAck(long zxid) {
<span class="fc bfc" id="L128" title="All 2 branches covered.">             if (currentZxid == zxid) {</span>
<span class="fc" id="L129">                 currentTime = nextTime;</span>
<span class="fc" id="L130">                 currentZxid = nextZxid;</span>
<span class="fc" id="L131">                 nextTime = 0;</span>
<span class="fc" id="L132">                 nextZxid = 0;</span>
<span class="pc bpc" id="L133" title="1 of 2 branches missed.">             } else if (nextZxid == zxid) {</span>
<span class="nc" id="L134">                 LOG.warn(&quot;ACK for &quot; + zxid + &quot; received before ACK for &quot; + currentZxid + &quot;!!!!&quot;);</span>
<span class="nc" id="L135">                 nextTime = 0;</span>
<span class="nc" id="L136">                 nextZxid = 0;</span>
             }
<span class="fc" id="L138">        }</span>

        public synchronized boolean check(long time) {
<span class="fc bfc" id="L141" title="All 2 branches covered.">            if (currentTime == 0) {</span>
<span class="fc" id="L142">                return true;</span>
            } else {
<span class="fc" id="L144">                long msDelay = (time - currentTime) / 1000000;</span>
<span class="fc bfc" id="L145" title="All 2 branches covered.">                return (msDelay &lt; (leader.self.tickTime * leader.self.syncLimit));</span>
            }
        }
    };

<span class="fc" id="L150">    private SyncLimitCheck syncLimitCheck = new SyncLimitCheck();</span>

    private BinaryInputArchive ia;

    private BinaryOutputArchive oa;

    private BufferedOutputStream bufferedOutput;

    LearnerHandler(Socket sock, Leader leader) throws IOException {
<span class="fc" id="L159">        super(&quot;LearnerHandler-&quot; + sock.getRemoteSocketAddress());</span>
<span class="fc" id="L160">        this.sock = sock;</span>
<span class="fc" id="L161">        this.leader = leader;</span>
<span class="fc" id="L162">        leader.addLearnerHandler(this);</span>
<span class="fc" id="L163">    }</span>
    
    @Override
    public String toString() {
<span class="fc" id="L167">        StringBuilder sb = new StringBuilder();</span>
<span class="fc" id="L168">        sb.append(&quot;LearnerHandler &quot;).append(sock);</span>
<span class="fc" id="L169">        sb.append(&quot; tickOfNextAckDeadline:&quot;).append(tickOfNextAckDeadline());</span>
<span class="fc" id="L170">        sb.append(&quot; synced?:&quot;).append(synced());</span>
<span class="fc" id="L171">        sb.append(&quot; queuedPacketLength:&quot;).append(queuedPackets.size());</span>
<span class="fc" id="L172">        return sb.toString();</span>
    }

    /**
     * If this packet is queued, the sender thread will exit
     */
<span class="fc" id="L178">    final QuorumPacket proposalOfDeath = new QuorumPacket();</span>

<span class="fc" id="L180">    private LearnerType  learnerType = LearnerType.PARTICIPANT;</span>
    public LearnerType getLearnerType() {
<span class="fc" id="L182">        return learnerType;</span>
    }

    /**
     * This method will use the thread to send packets added to the
     * queuedPackets list
     *
     * @throws InterruptedException
     */
    private void sendPackets() throws InterruptedException {
<span class="fc" id="L192">        long traceMask = ZooTrace.SERVER_PACKET_TRACE_MASK;</span>
        while (true) {
            try {
                QuorumPacket p;
<span class="fc" id="L196">                p = queuedPackets.poll();</span>
<span class="fc bfc" id="L197" title="All 2 branches covered.">                if (p == null) {</span>
<span class="fc" id="L198">                    bufferedOutput.flush();</span>
<span class="fc" id="L199">                    p = queuedPackets.take();</span>
                }

<span class="fc bfc" id="L202" title="All 2 branches covered.">                if (p == proposalOfDeath) {</span>
                    // Packet of death!
<span class="fc" id="L204">                    break;</span>
                }
<span class="fc bfc" id="L206" title="All 2 branches covered.">                if (p.getType() == Leader.PING) {</span>
<span class="fc" id="L207">                    traceMask = ZooTrace.SERVER_PING_TRACE_MASK;</span>
                }
<span class="fc bfc" id="L209" title="All 2 branches covered.">                if (p.getType() == Leader.PROPOSAL) {</span>
<span class="fc" id="L210">                    syncLimitCheck.updateProposal(p.getZxid(), System.nanoTime());</span>
                }
<span class="pc bpc" id="L212" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L213">                    ZooTrace.logQuorumPacket(LOG, traceMask, 'o', p);</span>
                }
<span class="fc" id="L215">                oa.writeRecord(p, &quot;packet&quot;);</span>
<span class="fc" id="L216">            } catch (IOException e) {</span>
<span class="pc bpc" id="L217" title="1 of 2 branches missed.">                if (!sock.isClosed()) {</span>
<span class="fc" id="L218">                    LOG.warn(&quot;Unexpected exception at &quot; + this, e);</span>
                    try {
                        // this will cause everything to shutdown on
                        // this learner handler and will help notify
                        // the learner/observer instantaneously
<span class="fc" id="L223">                        sock.close();</span>
<span class="nc" id="L224">                    } catch(IOException ie) {</span>
<span class="nc" id="L225">                        LOG.warn(&quot;Error closing socket for handler &quot; + this, ie);</span>
<span class="fc" id="L226">                    }</span>
                }
<span class="fc" id="L228">                break;</span>
<span class="fc" id="L229">            }</span>
        }
<span class="fc" id="L231">    }</span>

    static public String packetToString(QuorumPacket p) {
<span class="nc" id="L234">        String type = null;</span>
<span class="nc" id="L235">        String mess = null;</span>
<span class="nc" id="L236">        Record txn = null;</span>
        
<span class="nc bnc" id="L238" title="All 10 branches missed.">        switch (p.getType()) {</span>
        case Leader.ACK:
<span class="nc" id="L240">            type = &quot;ACK&quot;;</span>
<span class="nc" id="L241">            break;</span>
        case Leader.COMMIT:
<span class="nc" id="L243">            type = &quot;COMMIT&quot;;</span>
<span class="nc" id="L244">            break;</span>
        case Leader.FOLLOWERINFO:
<span class="nc" id="L246">            type = &quot;FOLLOWERINFO&quot;;</span>
<span class="nc" id="L247">            break;    </span>
        case Leader.NEWLEADER:
<span class="nc" id="L249">            type = &quot;NEWLEADER&quot;;</span>
<span class="nc" id="L250">            break;</span>
        case Leader.PING:
<span class="nc" id="L252">            type = &quot;PING&quot;;</span>
<span class="nc" id="L253">            break;</span>
        case Leader.PROPOSAL:
<span class="nc" id="L255">            type = &quot;PROPOSAL&quot;;</span>
<span class="nc" id="L256">            TxnHeader hdr = new TxnHeader();</span>
            try {
<span class="nc" id="L258">                txn = SerializeUtils.deserializeTxn(p.getData(), hdr);</span>
                // mess = &quot;transaction: &quot; + txn.toString();
<span class="nc" id="L260">            } catch (IOException e) {</span>
<span class="nc" id="L261">                LOG.warn(&quot;Unexpected exception&quot;,e);</span>
<span class="nc" id="L262">            }</span>
<span class="nc" id="L263">            break;</span>
        case Leader.REQUEST:
<span class="nc" id="L265">            type = &quot;REQUEST&quot;;</span>
<span class="nc" id="L266">            break;</span>
        case Leader.REVALIDATE:
<span class="nc" id="L268">            type = &quot;REVALIDATE&quot;;</span>
<span class="nc" id="L269">            ByteArrayInputStream bis = new ByteArrayInputStream(p.getData());</span>
<span class="nc" id="L270">            DataInputStream dis = new DataInputStream(bis);</span>
            try {
<span class="nc" id="L272">                long id = dis.readLong();</span>
<span class="nc" id="L273">                mess = &quot; sessionid = &quot; + id;</span>
<span class="nc" id="L274">            } catch (IOException e) {</span>
<span class="nc" id="L275">                LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L276">            }</span>

<span class="nc" id="L278">            break;</span>
        case Leader.UPTODATE:
<span class="nc" id="L280">            type = &quot;UPTODATE&quot;;</span>
<span class="nc" id="L281">            break;</span>
        default:
<span class="nc" id="L283">            type = &quot;UNKNOWN&quot; + p.getType();</span>
        }
<span class="nc" id="L285">        String entry = null;</span>
<span class="nc bnc" id="L286" title="All 2 branches missed.">        if (type != null) {</span>
<span class="nc" id="L287">            entry = type + &quot; &quot; + Long.toHexString(p.getZxid()) + &quot; &quot; + mess;</span>
        }
<span class="nc" id="L289">        return entry;</span>
    }

    /**
     * This thread will receive packets from the peer and process them and
     * also listen to new connections from new peers.
     */
    @Override
    public void run() {
        try {
<span class="fc" id="L299">            tickOfNextAckDeadline = leader.self.tick</span>
                    + leader.self.initLimit + leader.self.syncLimit;

<span class="fc" id="L302">            ia = BinaryInputArchive.getArchive(new BufferedInputStream(sock</span>
<span class="fc" id="L303">                    .getInputStream()));</span>
<span class="fc" id="L304">            bufferedOutput = new BufferedOutputStream(sock.getOutputStream());</span>
<span class="fc" id="L305">            oa = BinaryOutputArchive.getArchive(bufferedOutput);</span>

<span class="fc" id="L307">            QuorumPacket qp = new QuorumPacket();</span>
<span class="fc" id="L308">            ia.readRecord(qp, &quot;packet&quot;);</span>
<span class="pc bpc" id="L309" title="1 of 4 branches missed.">            if(qp.getType() != Leader.FOLLOWERINFO &amp;&amp; qp.getType() != Leader.OBSERVERINFO){</span>
<span class="nc" id="L310">            	LOG.error(&quot;First packet &quot; + qp.toString()</span>
                        + &quot; is not FOLLOWERINFO or OBSERVERINFO!&quot;);
<span class="nc" id="L312">                return;</span>
            }
<span class="fc" id="L314">            byte learnerInfoData[] = qp.getData();</span>
<span class="pc bpc" id="L315" title="1 of 2 branches missed.">            if (learnerInfoData != null) {</span>
<span class="pc bpc" id="L316" title="1 of 2 branches missed.">            	if (learnerInfoData.length == 8) {</span>
<span class="nc" id="L317">            		ByteBuffer bbsid = ByteBuffer.wrap(learnerInfoData);</span>
<span class="nc" id="L318">            		this.sid = bbsid.getLong();</span>
<span class="nc" id="L319">            	} else {</span>
<span class="fc" id="L320">            		LearnerInfo li = new LearnerInfo();</span>
<span class="fc" id="L321">            		ByteBufferInputStream.byteBuffer2Record(ByteBuffer.wrap(learnerInfoData), li);</span>
<span class="fc" id="L322">            		this.sid = li.getServerid();</span>
<span class="fc" id="L323">            		this.version = li.getProtocolVersion();</span>
<span class="fc" id="L324">            	}</span>
            } else {
<span class="nc" id="L326">            	this.sid = leader.followerCounter.getAndDecrement();</span>
            }

<span class="fc" id="L329">            LOG.info(&quot;Follower sid: &quot; + sid + &quot; : info : &quot;</span>
<span class="fc" id="L330">                    + leader.self.quorumPeers.get(sid));</span>
                        
<span class="fc bfc" id="L332" title="All 2 branches covered.">            if (qp.getType() == Leader.OBSERVERINFO) {</span>
<span class="fc" id="L333">                  learnerType = LearnerType.OBSERVER;</span>
            }            
            
<span class="fc" id="L336">            long lastAcceptedEpoch = ZxidUtils.getEpochFromZxid(qp.getZxid());</span>
            
            long peerLastZxid;
<span class="fc" id="L339">            StateSummary ss = null;</span>
<span class="fc" id="L340">            long zxid = qp.getZxid();</span>
<span class="fc" id="L341">            long newEpoch = leader.getEpochToPropose(this.getSid(), lastAcceptedEpoch);</span>
            
<span class="pc bpc" id="L343" title="1 of 2 branches missed.">            if (this.getVersion() &lt; 0x10000) {</span>
                // we are going to have to extrapolate the epoch information
<span class="nc" id="L345">                long epoch = ZxidUtils.getEpochFromZxid(zxid);</span>
<span class="nc" id="L346">                ss = new StateSummary(epoch, zxid);</span>
                // fake the message
<span class="nc" id="L348">                leader.waitForEpochAck(this.getSid(), ss);</span>
<span class="nc" id="L349">            } else {</span>
<span class="fc" id="L350">                byte ver[] = new byte[4];</span>
<span class="fc" id="L351">                ByteBuffer.wrap(ver).putInt(0x10000);</span>
<span class="fc" id="L352">                QuorumPacket newEpochPacket = new QuorumPacket(Leader.LEADERINFO, ZxidUtils.makeZxid(newEpoch, 0), ver, null);</span>
<span class="fc" id="L353">                oa.writeRecord(newEpochPacket, &quot;packet&quot;);</span>
<span class="fc" id="L354">                bufferedOutput.flush();</span>
<span class="fc" id="L355">                QuorumPacket ackEpochPacket = new QuorumPacket();</span>
<span class="fc" id="L356">                ia.readRecord(ackEpochPacket, &quot;packet&quot;);</span>
<span class="pc bpc" id="L357" title="1 of 2 branches missed.">                if (ackEpochPacket.getType() != Leader.ACKEPOCH) {</span>
<span class="nc" id="L358">                    LOG.error(ackEpochPacket.toString()</span>
                            + &quot; is not ACKEPOCH&quot;);
<span class="nc" id="L360">                    return;</span>
				}
<span class="fc" id="L362">                ByteBuffer bbepoch = ByteBuffer.wrap(ackEpochPacket.getData());</span>
<span class="fc" id="L363">                ss = new StateSummary(bbepoch.getInt(), ackEpochPacket.getZxid());</span>
<span class="fc" id="L364">                leader.waitForEpochAck(this.getSid(), ss);</span>
            }
<span class="fc" id="L366">            peerLastZxid = ss.getLastZxid();</span>
            
            /* the default to send to the follower */
<span class="fc" id="L369">            int packetToSend = Leader.SNAP;</span>
<span class="fc" id="L370">            long zxidToSend = 0;</span>
<span class="fc" id="L371">            long leaderLastZxid = 0;</span>
            /** the packets that the follower needs to get updates from **/
<span class="fc" id="L373">            long updates = peerLastZxid;</span>
            
            /* we are sending the diff check if we have proposals in memory to be able to 
             * send a diff to the 
             */ 
<span class="fc" id="L378">            ReentrantReadWriteLock lock = leader.zk.getZKDatabase().getLogLock();</span>
<span class="fc" id="L379">            ReadLock rl = lock.readLock();</span>
            try {
<span class="fc" id="L381">                rl.lock();        </span>
<span class="fc" id="L382">                final long maxCommittedLog = leader.zk.getZKDatabase().getmaxCommittedLog();</span>
<span class="fc" id="L383">                final long minCommittedLog = leader.zk.getZKDatabase().getminCommittedLog();</span>
<span class="fc" id="L384">                LOG.info(&quot;Synchronizing with Follower sid: &quot; + sid</span>
<span class="fc" id="L385">                        +&quot; maxCommittedLog=0x&quot;+Long.toHexString(maxCommittedLog)</span>
<span class="fc" id="L386">                        +&quot; minCommittedLog=0x&quot;+Long.toHexString(minCommittedLog)</span>
<span class="fc" id="L387">                        +&quot; peerLastZxid=0x&quot;+Long.toHexString(peerLastZxid));</span>

<span class="fc" id="L389">                LinkedList&lt;Proposal&gt; proposals = leader.zk.getZKDatabase().getCommittedLog();</span>

<span class="fc bfc" id="L391" title="All 2 branches covered.">                if (peerLastZxid == leader.zk.getZKDatabase().getDataTreeLastProcessedZxid()) {</span>
                    // Follower is already sync with us, send empty diff
<span class="fc" id="L393">                    LOG.info(&quot;leader and follower are in sync, zxid=0x{}&quot;,</span>
<span class="fc" id="L394">                            Long.toHexString(peerLastZxid));</span>
<span class="fc" id="L395">                    packetToSend = Leader.DIFF;</span>
<span class="fc" id="L396">                    zxidToSend = peerLastZxid;</span>
<span class="fc bfc" id="L397" title="All 2 branches covered.">                } else if (proposals.size() != 0) {</span>
<span class="fc" id="L398">                    LOG.debug(&quot;proposal size is {}&quot;, proposals.size());</span>
<span class="pc bpc" id="L399" title="1 of 4 branches missed.">                    if ((maxCommittedLog &gt;= peerLastZxid)</span>
                            &amp;&amp; (minCommittedLog &lt;= peerLastZxid)) {
<span class="fc" id="L401">                        LOG.debug(&quot;Sending proposals to follower&quot;);</span>

                        // as we look through proposals, this variable keeps track of previous
                        // proposal Id.
<span class="fc" id="L405">                        long prevProposalZxid = minCommittedLog;</span>

                        // Keep track of whether we are about to send the first packet.
                        // Before sending the first packet, we have to tell the learner
                        // whether to expect a trunc or a diff
<span class="fc" id="L410">                        boolean firstPacket=true;</span>

                        // If we are here, we can use committedLog to sync with
                        // follower. Then we only need to decide whether to
                        // send trunc or not
<span class="fc" id="L415">                        packetToSend = Leader.DIFF;</span>
<span class="fc" id="L416">                        zxidToSend = maxCommittedLog;</span>

<span class="fc bfc" id="L418" title="All 2 branches covered.">                        for (Proposal propose: proposals) {</span>
                            // skip the proposals the peer already has
<span class="fc bfc" id="L420" title="All 2 branches covered.">                            if (propose.packet.getZxid() &lt;= peerLastZxid) {</span>
<span class="fc" id="L421">                                prevProposalZxid = propose.packet.getZxid();</span>
<span class="fc" id="L422">                                continue;</span>
                            } else {
                                // If we are sending the first packet, figure out whether to trunc
                                // in case the follower has some proposals that the leader doesn't
<span class="fc bfc" id="L426" title="All 2 branches covered.">                                if (firstPacket) {</span>
<span class="fc" id="L427">                                    firstPacket = false;</span>
                                    // Does the peer have some proposals that the leader hasn't seen yet
<span class="fc bfc" id="L429" title="All 2 branches covered.">                                    if (prevProposalZxid &lt; peerLastZxid) {</span>
                                        // send a trunc message before sending the diff
<span class="fc" id="L431">                                        packetToSend = Leader.TRUNC;                                        </span>
<span class="fc" id="L432">                                        zxidToSend = prevProposalZxid;</span>
<span class="fc" id="L433">                                        updates = zxidToSend;</span>
                                    }
                                }
<span class="fc" id="L436">                                queuePacket(propose.packet);</span>
<span class="fc" id="L437">                                QuorumPacket qcommit = new QuorumPacket(Leader.COMMIT, propose.packet.getZxid(),</span>
                                        null, null);
<span class="fc" id="L439">                                queuePacket(qcommit);</span>
                            }
<span class="fc" id="L441">                        }</span>
<span class="pc bpc" id="L442" title="1 of 2 branches missed.">                    } else if (peerLastZxid &gt; maxCommittedLog) {</span>
<span class="nc" id="L443">                        LOG.debug(&quot;Sending TRUNC to follower zxidToSend=0x{} updates=0x{}&quot;,</span>
<span class="nc" id="L444">                                Long.toHexString(maxCommittedLog),</span>
<span class="nc" id="L445">                                Long.toHexString(updates));</span>

<span class="nc" id="L447">                        packetToSend = Leader.TRUNC;</span>
<span class="nc" id="L448">                        zxidToSend = maxCommittedLog;</span>
<span class="nc" id="L449">                        updates = zxidToSend;</span>
                    } else {
<span class="fc" id="L451">                        LOG.warn(&quot;Unhandled proposal scenario&quot;);</span>
                    }
                } else {
                    // just let the state transfer happen
<span class="fc" id="L455">                    LOG.debug(&quot;proposals is empty&quot;);</span>
                }               

<span class="fc" id="L458">                LOG.info(&quot;Sending &quot; + Leader.getPacketType(packetToSend));</span>
<span class="fc" id="L459">                leaderLastZxid = leader.startForwarding(this, updates);</span>

<span class="fc" id="L461">            } finally {</span>
<span class="nc" id="L462">                rl.unlock();</span>
<span class="fc" id="L463">            }</span>

<span class="fc" id="L465">             QuorumPacket newLeaderQP = new QuorumPacket(Leader.NEWLEADER,</span>
<span class="fc" id="L466">                    ZxidUtils.makeZxid(newEpoch, 0), null, null);</span>
<span class="pc bpc" id="L467" title="1 of 2 branches missed.">             if (getVersion() &lt; 0x10000) {</span>
<span class="nc" id="L468">                oa.writeRecord(newLeaderQP, &quot;packet&quot;);</span>
            } else {
<span class="fc" id="L470">                queuedPackets.add(newLeaderQP);</span>
            }
<span class="fc" id="L472">            bufferedOutput.flush();</span>
            //Need to set the zxidToSend to the latest zxid
<span class="fc bfc" id="L474" title="All 2 branches covered.">            if (packetToSend == Leader.SNAP) {</span>
<span class="fc" id="L475">                zxidToSend = leader.zk.getZKDatabase().getDataTreeLastProcessedZxid();</span>
            }
<span class="fc" id="L477">            oa.writeRecord(new QuorumPacket(packetToSend, zxidToSend, null, null), &quot;packet&quot;);</span>
<span class="fc" id="L478">            bufferedOutput.flush();</span>
            
            /* if we are not truncating or sending a diff just send a snapshot */
<span class="fc bfc" id="L481" title="All 2 branches covered.">            if (packetToSend == Leader.SNAP) {</span>
<span class="fc" id="L482">                LOG.info(&quot;Sending snapshot last zxid of peer is 0x&quot;</span>
<span class="fc" id="L483">                        + Long.toHexString(peerLastZxid) + &quot; &quot; </span>
                        + &quot; zxid of leader is 0x&quot;
<span class="fc" id="L485">                        + Long.toHexString(leaderLastZxid)</span>
                        + &quot;sent zxid of db as 0x&quot; 
<span class="fc" id="L487">                        + Long.toHexString(zxidToSend));</span>
                // Dump data to peer
<span class="fc" id="L489">                leader.zk.getZKDatabase().serializeSnapshot(oa);</span>
<span class="fc" id="L490">                oa.writeString(&quot;BenWasHere&quot;, &quot;signature&quot;);</span>
            }
<span class="fc" id="L492">            bufferedOutput.flush();</span>
            
            // Start sending packets
<span class="fc" id="L495">            new Thread() {</span>
                public void run() {
<span class="fc" id="L497">                    Thread.currentThread().setName(</span>
<span class="fc" id="L498">                            &quot;Sender-&quot; + sock.getRemoteSocketAddress());</span>
                    try {
<span class="fc" id="L500">                        sendPackets();</span>
<span class="nc" id="L501">                    } catch (InterruptedException e) {</span>
<span class="nc" id="L502">                        LOG.warn(&quot;Unexpected interruption&quot;,e);</span>
<span class="fc" id="L503">                    }</span>
<span class="fc" id="L504">                }</span>
<span class="fc" id="L505">            }.start();</span>
            
            /*
             * Have to wait for the first ACK, wait until 
             * the leader is ready, and only then we can
             * start processing messages.
             */
<span class="fc" id="L512">            qp = new QuorumPacket();</span>
<span class="fc" id="L513">            ia.readRecord(qp, &quot;packet&quot;);</span>
<span class="pc bpc" id="L514" title="1 of 2 branches missed.">            if(qp.getType() != Leader.ACK){</span>
<span class="nc" id="L515">                LOG.error(&quot;Next packet was supposed to be an ACK&quot;);</span>
<span class="nc" id="L516">                return;</span>
            }
<span class="fc" id="L518">            LOG.info(&quot;Received NEWLEADER-ACK message from &quot; + getSid());</span>
<span class="fc" id="L519">            leader.waitForNewLeaderAck(getSid(), qp.getZxid(), getLearnerType());</span>

<span class="fc" id="L521">            syncLimitCheck.start();</span>
            
            // now that the ack has been processed expect the syncLimit
<span class="fc" id="L524">            sock.setSoTimeout(leader.self.tickTime * leader.self.syncLimit);</span>

            /*
             * Wait until leader starts up
             */
<span class="fc" id="L529">            synchronized(leader.zk){</span>
<span class="pc bpc" id="L530" title="1 of 4 branches missed.">                while(!leader.zk.isRunning() &amp;&amp; !this.isInterrupted()){</span>
<span class="fc" id="L531">                    leader.zk.wait(20);</span>
                }
<span class="pc" id="L533">            }</span>
            // Mutation packets will be queued during the serialize,
            // so we need to mark when the peer can actually start
            // using the data
            //
<span class="fc" id="L538">            queuedPackets.add(new QuorumPacket(Leader.UPTODATE, -1, null, null));</span>

            while (true) {
<span class="fc" id="L541">                qp = new QuorumPacket();</span>
<span class="fc" id="L542">                ia.readRecord(qp, &quot;packet&quot;);</span>

<span class="fc" id="L544">                long traceMask = ZooTrace.SERVER_PACKET_TRACE_MASK;</span>
<span class="fc bfc" id="L545" title="All 2 branches covered.">                if (qp.getType() == Leader.PING) {</span>
<span class="fc" id="L546">                    traceMask = ZooTrace.SERVER_PING_TRACE_MASK;</span>
                }
<span class="pc bpc" id="L548" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L549">                    ZooTrace.logQuorumPacket(LOG, traceMask, 'i', qp);</span>
                }
<span class="fc" id="L551">                tickOfNextAckDeadline = leader.self.tick + leader.self.syncLimit;</span>


                ByteBuffer bb;
                long sessionId;
                int cxid;
                int type;

<span class="pc bpc" id="L559" title="1 of 5 branches missed.">                switch (qp.getType()) {</span>
                case Leader.ACK:
<span class="fc bfc" id="L561" title="All 2 branches covered.">                    if (this.learnerType == LearnerType.OBSERVER) {</span>
<span class="pc bpc" id="L562" title="1 of 2 branches missed.">                        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L563">                            LOG.debug(&quot;Received ACK from Observer  &quot; + this.sid);</span>
                        }
                    }
<span class="fc" id="L566">                    syncLimitCheck.updateAck(qp.getZxid());</span>
<span class="fc" id="L567">                    leader.processAck(this.sid, qp.getZxid(), sock.getLocalSocketAddress());</span>
<span class="fc" id="L568">                    break;</span>
                case Leader.PING:
                    // Process the touches
<span class="fc" id="L571">                    ByteArrayInputStream bis = new ByteArrayInputStream(qp</span>
<span class="fc" id="L572">                            .getData());</span>
<span class="fc" id="L573">                    DataInputStream dis = new DataInputStream(bis);</span>
<span class="fc bfc" id="L574" title="All 2 branches covered.">                    while (dis.available() &gt; 0) {</span>
<span class="fc" id="L575">                        long sess = dis.readLong();</span>
<span class="fc" id="L576">                        int to = dis.readInt();</span>
<span class="fc" id="L577">                        leader.zk.touch(sess, to);</span>
<span class="fc" id="L578">                    }</span>
                    break;
                case Leader.REVALIDATE:
<span class="fc" id="L581">                    bis = new ByteArrayInputStream(qp.getData());</span>
<span class="fc" id="L582">                    dis = new DataInputStream(bis);</span>
<span class="fc" id="L583">                    long id = dis.readLong();</span>
<span class="fc" id="L584">                    int to = dis.readInt();</span>
<span class="fc" id="L585">                    ByteArrayOutputStream bos = new ByteArrayOutputStream();</span>
<span class="fc" id="L586">                    DataOutputStream dos = new DataOutputStream(bos);</span>
<span class="fc" id="L587">                    dos.writeLong(id);</span>
<span class="fc" id="L588">                    boolean valid = leader.zk.touch(id, to);</span>
<span class="pc bpc" id="L589" title="1 of 2 branches missed.">                    if (valid) {</span>
                        try {
                            //set the session owner
                            // as the follower that
                            // owns the session
<span class="fc" id="L594">                            leader.zk.setOwner(id, this);</span>
<span class="nc" id="L595">                        } catch (SessionExpiredException e) {</span>
<span class="nc" id="L596">                            LOG.error(&quot;Somehow session &quot; + Long.toHexString(id) + &quot; expired right after being renewed! (impossible)&quot;, e);</span>
<span class="fc" id="L597">                        }</span>
                    }
<span class="pc bpc" id="L599" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L600">                        ZooTrace.logTraceMessage(LOG,</span>
                                                 ZooTrace.SESSION_TRACE_MASK,
<span class="nc" id="L602">                                                 &quot;Session 0x&quot; + Long.toHexString(id)</span>
                                                 + &quot; is valid: &quot;+ valid);
                    }
<span class="fc" id="L605">                    dos.writeBoolean(valid);</span>
<span class="fc" id="L606">                    qp.setData(bos.toByteArray());</span>
<span class="fc" id="L607">                    queuedPackets.add(qp);</span>
<span class="fc" id="L608">                    break;</span>
                case Leader.REQUEST:                    
<span class="fc" id="L610">                    bb = ByteBuffer.wrap(qp.getData());</span>
<span class="fc" id="L611">                    sessionId = bb.getLong();</span>
<span class="fc" id="L612">                    cxid = bb.getInt();</span>
<span class="fc" id="L613">                    type = bb.getInt();</span>
<span class="fc" id="L614">                    bb = bb.slice();</span>
                    Request si;
<span class="fc bfc" id="L616" title="All 2 branches covered.">                    if(type == OpCode.sync){</span>
<span class="fc" id="L617">                        si = new LearnerSyncRequest(this, sessionId, cxid, type, bb, qp.getAuthinfo());</span>
                    } else {
<span class="fc" id="L619">                        si = new Request(null, sessionId, cxid, type, bb, qp.getAuthinfo());</span>
                    }
<span class="fc" id="L621">                    si.setOwner(this);</span>
<span class="fc" id="L622">                    leader.zk.submitRequest(si);</span>
<span class="fc" id="L623">                    break;</span>
                default:
<span class="nc" id="L625">                    LOG.warn(&quot;unexpected quorum packet, type: {}&quot;, packetToString(qp));</span>
                    break;
                }
<span class="fc" id="L628">            }</span>
<span class="fc" id="L629">        } catch (IOException e) {</span>
<span class="pc bpc" id="L630" title="1 of 4 branches missed.">            if (sock != null &amp;&amp; !sock.isClosed()) {</span>
<span class="fc" id="L631">                LOG.error(&quot;Unexpected exception causing shutdown while sock &quot;</span>
                        + &quot;still open&quot;, e);
            	//close the socket to make sure the 
            	//other side can see it being close
            	try {
<span class="fc" id="L636">            		sock.close();</span>
<span class="nc" id="L637">            	} catch(IOException ie) {</span>
            		// do nothing
<span class="fc" id="L639">            	}</span>
            }
<span class="pc" id="L641">        } catch (InterruptedException e) {</span>
<span class="nc" id="L642">            LOG.error(&quot;Unexpected exception causing shutdown&quot;, e);</span>
<span class="nc" id="L643">        } finally {</span>
<span class="pc" id="L644">            LOG.warn(&quot;******* GOODBYE &quot; </span>
<span class="pc" id="L645">                    + (sock != null ? sock.getRemoteSocketAddress() : &quot;&lt;null&gt;&quot;)</span>
                    + &quot; ********&quot;);
<span class="pc bpc" id="L647" title="9 of 10 branches missed.">            shutdown();</span>
<span class="pc" id="L648">        }</span>
<span class="pc bnc" id="L649" title="All 2 branches missed.">    }</span>

    public void shutdown() {
        // Send the packet of death
        try {
<span class="fc" id="L654">            queuedPackets.put(proposalOfDeath);</span>
<span class="fc" id="L655">        } catch (InterruptedException e) {</span>
<span class="fc" id="L656">            LOG.warn(&quot;Ignoring unexpected exception&quot;, e);</span>
<span class="fc" id="L657">        }</span>
        try {
<span class="pc bpc" id="L659" title="1 of 4 branches missed.">            if (sock != null &amp;&amp; !sock.isClosed()) {</span>
<span class="fc" id="L660">                sock.close();</span>
            }
<span class="nc" id="L662">        } catch (IOException e) {</span>
<span class="nc" id="L663">            LOG.warn(&quot;Ignoring unexpected exception during socket close&quot;, e);</span>
<span class="fc" id="L664">        }</span>
<span class="fc" id="L665">        this.interrupt();</span>
<span class="fc" id="L666">        leader.removeLearnerHandler(this);</span>
<span class="fc" id="L667">    }</span>

    public long tickOfNextAckDeadline() {
<span class="fc" id="L670">        return tickOfNextAckDeadline;</span>
    }

    /**
     * ping calls from the leader to the peers
     */
    public void ping() {
        long id;
<span class="fc bfc" id="L678" title="All 2 branches covered.">        if (syncLimitCheck.check(System.nanoTime())) {</span>
<span class="fc" id="L679">            synchronized(leader) {</span>
<span class="fc" id="L680">                id = leader.lastProposed;</span>
<span class="pc" id="L681">            }</span>
<span class="fc" id="L682">            QuorumPacket ping = new QuorumPacket(Leader.PING, id, null, null);</span>
<span class="fc" id="L683">            queuePacket(ping);</span>
<span class="fc" id="L684">        } else {</span>
<span class="fc" id="L685">            LOG.warn(&quot;Closing connection to peer due to transaction timeout.&quot;);</span>
<span class="fc" id="L686">            shutdown();</span>
        }
<span class="fc" id="L688">    }</span>

    void queuePacket(QuorumPacket p) {
<span class="fc" id="L691">        queuedPackets.add(p);</span>
<span class="fc" id="L692">    }</span>

    public boolean synced() {
<span class="fc bfc" id="L695" title="All 4 branches covered.">        return isAlive()</span>
        &amp;&amp; leader.self.tick &lt;= tickOfNextAckDeadline;
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>